Index: uspace/lib/output/src/chargrid.c
===================================================================
--- uspace/lib/output/src/chargrid.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/output/src/chargrid.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,362 @@
+/*
+ * Copyright (c) 2006 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup liboutput
+ * @{
+ */
+/** @file
+ */
+
+#include <io/style.h>
+#include <stdlib.h>
+#include <assert.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <as.h>
+#include <io/chargrid.h>
+
+/** Create a chargrid.
+ *
+ * @param[in] cols  Number of columns.
+ * @param[in] rows  Number of rows.
+ * @param[in] flags Chargrid flags.
+ *
+ * @return New chargrid.
+ * @return NULL on failure.
+ *
+ */
+chargrid_t *chargrid_create(sysarg_t cols, sysarg_t rows,
+    chargrid_flag_t flags)
+{
+	size_t size =
+	    sizeof(chargrid_t) + cols * rows * sizeof(charfield_t);
+	chargrid_t *scrbuf;
+
+	if ((flags & CHARGRID_FLAG_SHARED) == CHARGRID_FLAG_SHARED) {
+		scrbuf = (chargrid_t *) as_area_create(AS_AREA_ANY, size,
+		    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
+		    AS_AREA_UNPAGED);
+		if (scrbuf == AS_MAP_FAILED)
+			return NULL;
+	} else {
+		scrbuf = (chargrid_t *) malloc(size);
+		if (scrbuf == NULL)
+			return NULL;
+	}
+
+	scrbuf->size = size;
+	scrbuf->flags = flags;
+	scrbuf->cols = cols;
+	scrbuf->rows = rows;
+	scrbuf->cursor_visible = false;
+
+	scrbuf->attrs.type = CHAR_ATTR_STYLE;
+	scrbuf->attrs.val.style = STYLE_NORMAL;
+
+	scrbuf->top_row = 0;
+	chargrid_clear(scrbuf);
+
+	return scrbuf;
+}
+
+void chargrid_destroy(chargrid_t *srcbuf)
+{
+	// TODO
+}
+
+bool chargrid_cursor_at(chargrid_t *scrbuf, sysarg_t col, sysarg_t row)
+{
+	return ((scrbuf->cursor_visible) && (scrbuf->col == col) &&
+	    (scrbuf->row == row));
+}
+
+sysarg_t chargrid_get_top_row(chargrid_t *scrbuf)
+{
+	return scrbuf->top_row;
+}
+
+static sysarg_t chargrid_update_rows(chargrid_t *scrbuf)
+{
+	if (scrbuf->row == scrbuf->rows) {
+		scrbuf->row = scrbuf->rows - 1;
+		scrbuf->top_row = (scrbuf->top_row + 1) % scrbuf->rows;
+		chargrid_clear_row(scrbuf, scrbuf->row);
+
+		return scrbuf->rows;
+	}
+
+	return 2;
+}
+
+static sysarg_t chargrid_update_cols(chargrid_t *scrbuf)
+{
+	/* Column overflow */
+	if (scrbuf->col == scrbuf->cols) {
+		scrbuf->col = 0;
+		scrbuf->row++;
+		return chargrid_update_rows(scrbuf);
+	}
+
+	return 1;
+}
+
+/** Store one character to chargrid.
+ *
+ * Its position is determined by scrbuf->col
+ * and scrbuf->row.
+ *
+ * @param scrbuf Chargrid.
+ * @param ch     Character to store.
+ * @param update Update coordinates.
+ *
+ * @return Number of rows which have been affected. In usual
+ *         situations this is 1. If the current position was
+ *         updated to a new row, this value is 2.
+ *
+ */
+sysarg_t chargrid_putuchar(chargrid_t *scrbuf, char32_t ch, bool update)
+{
+	assert(scrbuf->col < scrbuf->cols);
+	assert(scrbuf->row < scrbuf->rows);
+
+	charfield_t *field =
+	    chargrid_charfield_at(scrbuf, scrbuf->col, scrbuf->row);
+
+	field->ch = ch;
+	field->attrs = scrbuf->attrs;
+	field->flags |= CHAR_FLAG_DIRTY;
+
+	if (update) {
+		scrbuf->col++;
+		return chargrid_update_cols(scrbuf);
+	}
+
+	return 1;
+}
+
+/** Jump to a new row in chargrid.
+ *
+ * @param scrbuf Chargrid.
+ *
+ * @return Number of rows which have been affected. In usual
+ *         situations this is 2 (the original row and the new
+ *         row).
+ *
+ */
+sysarg_t chargrid_newline(chargrid_t *scrbuf)
+{
+	assert(scrbuf->col < scrbuf->cols);
+	assert(scrbuf->row < scrbuf->rows);
+
+	scrbuf->col = 0;
+	scrbuf->row++;
+
+	return chargrid_update_rows(scrbuf);
+}
+
+/** Jump to a new row in chargrid.
+ *
+ * @param scrbuf   Chargrid.
+ * @param tab_size Tab size.
+ *
+ * @return Number of rows which have been affected. In usual
+ *         situations this is 1. If the current position was
+ *         updated to a new row, this value is 2.
+ *
+ */
+sysarg_t chargrid_tabstop(chargrid_t *scrbuf, sysarg_t tab_size)
+{
+	assert(scrbuf->col < scrbuf->cols);
+	assert(scrbuf->row < scrbuf->rows);
+
+	sysarg_t spaces = tab_size - scrbuf->cols % tab_size;
+	sysarg_t flush = 1;
+
+	for (sysarg_t i = 0; i < spaces; i++)
+		flush += chargrid_putuchar(scrbuf, ' ', true) - 1;
+
+	return flush;
+}
+
+/** Jump to the previous character in chargrid.
+ *
+ * Currently no scrollback is supported.
+ *
+ * @param scrbuf Chargrid.
+ *
+ * @return Number of rows which have been affected. In usual
+ *         situations this is 1. If the current position was
+ *         updated to the previous row, this value is 2.
+ * @return 0 if no backspace is possible.
+ *
+ */
+sysarg_t chargrid_backspace(chargrid_t *scrbuf)
+{
+	assert(scrbuf->col < scrbuf->cols);
+	assert(scrbuf->row < scrbuf->rows);
+
+	if ((scrbuf->col == 0) && (scrbuf->row == 0))
+		return 0;
+
+	if (scrbuf->col == 0) {
+		scrbuf->col = scrbuf->cols - 1;
+		scrbuf->row--;
+
+		chargrid_putuchar(scrbuf, ' ', false);
+		return 2;
+	}
+
+	scrbuf->col--;
+	chargrid_putuchar(scrbuf, ' ', false);
+	return 1;
+}
+
+/** Clear the chargrid.
+ *
+ * @param scrbuf Chargrid.
+ *
+ */
+void chargrid_clear(chargrid_t *scrbuf)
+{
+	for (size_t pos = 0; pos < (scrbuf->cols * scrbuf->rows); pos++) {
+		scrbuf->data[pos].ch = 0;
+		scrbuf->data[pos].attrs = scrbuf->attrs;
+		scrbuf->data[pos].flags = CHAR_FLAG_DIRTY;
+	}
+
+	scrbuf->col = 0;
+	scrbuf->row = 0;
+}
+
+/** Update current chargrid coordinates
+ *
+ * @param scrbuf Chargrid.
+ * @param col    New column.
+ * @param row    New row.
+ *
+ */
+void chargrid_set_cursor(chargrid_t *scrbuf, sysarg_t col, sysarg_t row)
+{
+	if (col >= scrbuf->cols || row >= scrbuf->rows)
+		return;
+
+	scrbuf->col = col;
+	scrbuf->row = row;
+}
+
+void chargrid_set_cursor_visibility(chargrid_t *scrbuf, bool visible)
+{
+	scrbuf->cursor_visible = visible;
+}
+
+/** Get current chargrid coordinates
+ *
+ * @param scrbuf Chargrid.
+ * @param col    Column.
+ * @param row    Row.
+ *
+ */
+void chargrid_get_cursor(chargrid_t *scrbuf, sysarg_t *col,
+    sysarg_t *row)
+{
+	assert(col);
+	assert(row);
+
+	*col = scrbuf->col;
+	*row = scrbuf->row;
+}
+
+bool chargrid_get_cursor_visibility(chargrid_t *scrbuf)
+{
+	return scrbuf->cursor_visible;
+}
+
+/** Clear one buffer row.
+ *
+ * @param scrbuf Chargrid.
+ * @param row    Row to clear.
+ *
+ */
+void chargrid_clear_row(chargrid_t *scrbuf, sysarg_t row)
+{
+	for (sysarg_t col = 0; col < scrbuf->cols; col++) {
+		charfield_t *field =
+		    chargrid_charfield_at(scrbuf, col, row);
+
+		field->ch = 0;
+		field->attrs = scrbuf->attrs;
+		field->flags |= CHAR_FLAG_DIRTY;
+	}
+}
+
+/** Set chargrid style.
+ *
+ * @param scrbuf Chargrid.
+ * @param style  Style.
+ *
+ */
+void chargrid_set_style(chargrid_t *scrbuf, console_style_t style)
+{
+	scrbuf->attrs.type = CHAR_ATTR_STYLE;
+	scrbuf->attrs.val.style = style;
+}
+
+/** Set chargrid color.
+ *
+ * @param scrbuf  Chargrid.
+ * @param bgcolor Background color.
+ * @param fgcolor Foreground color.
+ * @param attr    Color attribute.
+ *
+ */
+void chargrid_set_color(chargrid_t *scrbuf, console_color_t bgcolor,
+    console_color_t fgcolor, console_color_attr_t attr)
+{
+	scrbuf->attrs.type = CHAR_ATTR_INDEX;
+	scrbuf->attrs.val.index.bgcolor = bgcolor;
+	scrbuf->attrs.val.index.fgcolor = fgcolor;
+	scrbuf->attrs.val.index.attr = attr;
+}
+
+/** Set chargrid RGB color.
+ *
+ * @param scrbuf  Chargrid.
+ * @param bgcolor Background color.
+ * @param fgcolor Foreground color.
+ *
+ */
+void chargrid_set_rgb_color(chargrid_t *scrbuf, pixel_t bgcolor,
+    pixel_t fgcolor)
+{
+	scrbuf->attrs.type = CHAR_ATTR_RGB;
+	scrbuf->attrs.val.rgb.bgcolor = bgcolor;
+	scrbuf->attrs.val.rgb.fgcolor = fgcolor;
+}
+
+/** @}
+ */
Index: uspace/lib/output/src/output.c
===================================================================
--- uspace/lib/output/src/output.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/output/src/output.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,144 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup liboutput
+ * @{
+ */
+/** @file
+ */
+
+#include <async.h>
+#include <errno.h>
+#include <as.h>
+#include <ipc/output.h>
+#include <io/concaps.h>
+#include <io/output.h>
+
+errno_t output_yield(async_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_0_0(exch, OUTPUT_YIELD);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_claim(async_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_0_0(exch, OUTPUT_CLAIM);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_get_dimensions(async_sess_t *sess, sysarg_t *maxx, sysarg_t *maxy)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_0_2(exch, OUTPUT_GET_DIMENSIONS, maxx, maxy);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_get_caps(async_sess_t *sess, console_caps_t *ccaps)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+
+	sysarg_t rv;
+	errno_t ret = async_req_0_1(exch, OUTPUT_GET_CAPS, &rv);
+
+	async_exchange_end(exch);
+
+	if (ret == EOK)
+		*ccaps = (console_caps_t) rv;
+
+	return ret;
+}
+
+frontbuf_handle_t output_frontbuf_create(async_sess_t *sess,
+    chargrid_t *frontbuf)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+
+	ipc_call_t answer;
+	aid_t req = async_send_0(exch, OUTPUT_FRONTBUF_CREATE, &answer);
+	errno_t rc = async_share_out_start(exch, frontbuf, AS_AREA_READ |
+	    AS_AREA_WRITE | AS_AREA_CACHEABLE);
+
+	async_exchange_end(exch);
+
+	errno_t ret;
+	async_wait_for(req, &ret);
+
+	if ((rc != EOK) || (ret != EOK))
+		return 0;
+
+	return (frontbuf_handle_t) ipc_get_arg1(&answer);
+}
+
+errno_t output_set_style(async_sess_t *sess, console_style_t style)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_1_0(exch, OUTPUT_SET_STYLE, style);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_cursor_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_1_0(exch, OUTPUT_CURSOR_UPDATE, frontbuf);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_1_0(exch, OUTPUT_UPDATE, frontbuf);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+errno_t output_damage(async_sess_t *sess, frontbuf_handle_t frontbuf, sysarg_t col,
+    sysarg_t row, sysarg_t cols, sysarg_t rows)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	errno_t ret = async_req_5_0(exch, OUTPUT_DAMAGE, frontbuf, col, row,
+	    cols, rows);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+/** @}
+ */
Index: uspace/lib/posix/meson.build
===================================================================
--- uspace/lib/posix/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/posix/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -66,4 +66,3 @@
 uspace_lib_devel_install_script_text += 'mkdir -p "${DESTDIR}include/libposix"'
 uspace_lib_devel_install_script_text += 'cp -R -L -T "@0@" "${DESTDIR}include/libposix"'.format(_sdir)
-
-# TODO: exports
+uspace_lib_devel_install_script_text += 'ln -s -r "${DESTDIR}include/libc" "${DESTDIR}/include/common"'
Index: uspace/lib/tbarcfg/include/tbarcfg/tbarcfg.h
===================================================================
--- uspace/lib/tbarcfg/include/tbarcfg/tbarcfg.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/tbarcfg/include/tbarcfg/tbarcfg.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -38,6 +38,8 @@
 
 #include <errno.h>
+#include <sif.h>
 #include <types/tbarcfg/tbarcfg.h>
 
+extern errno_t tbarcfg_create(const char *, tbarcfg_t **);
 extern errno_t tbarcfg_open(const char *, tbarcfg_t **);
 extern void tbarcfg_close(tbarcfg_t *);
@@ -49,4 +51,6 @@
 extern errno_t smenu_entry_set_cmd(smenu_entry_t *, const char *);
 extern errno_t smenu_entry_save(smenu_entry_t *);
+extern errno_t smenu_entry_create(tbarcfg_t *, const char *, const char *);
+extern errno_t smenu_entry_destroy(smenu_entry_t *);
 
 #endif
Index: uspace/lib/tbarcfg/private/tbarcfg.h
===================================================================
--- uspace/lib/tbarcfg/private/tbarcfg.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/tbarcfg/private/tbarcfg.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -48,4 +48,6 @@
 	/** List of start menu entries (smenu_entry_t) */
 	list_t entries;
+	/** Entries SIF node */
+	sif_node_t *nentries;
 };
 
@@ -64,6 +66,7 @@
 };
 
-extern errno_t smenu_entry_create(tbarcfg_t *, sif_node_t *, const char *,
+extern errno_t smenu_entry_new(tbarcfg_t *, sif_node_t *, const char *,
     const char *);
+extern void smenu_entry_delete(smenu_entry_t *);
 
 #endif
Index: uspace/lib/tbarcfg/src/tbarcfg.c
===================================================================
--- uspace/lib/tbarcfg/src/tbarcfg.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/tbarcfg/src/tbarcfg.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -41,4 +41,58 @@
 #include "../private/tbarcfg.h"
 
+/** Create taskbar configuration.
+ *
+ * @param repopath Pathname of the new menu repository
+ * @param rtbcfg Place to store pointer to taskbar configuration
+ * @return EOK on success or an error code
+ */
+errno_t tbarcfg_create(const char *repopath, tbarcfg_t **rtbcfg)
+{
+	tbarcfg_t *tbcfg;
+	sif_sess_t *repo = NULL;
+	sif_node_t *rnode;
+	errno_t rc;
+	sif_trans_t *trans = NULL;
+
+	tbcfg = calloc(1, sizeof(tbarcfg_t));
+	if (tbcfg == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	list_initialize(&tbcfg->entries);
+
+	rc = sif_create(repopath, &repo);
+	if (rc != EOK)
+		goto error;
+
+	tbcfg->repo = repo;
+
+	rnode = sif_get_root(repo);
+
+	rc = sif_trans_begin(repo, &trans);
+	if (rc != EOK)
+		goto error;
+
+	rc = sif_node_append_child(trans, rnode, "entries", &tbcfg->nentries);
+	if (rc != EOK)
+		goto error;
+
+	rc = sif_trans_end(trans);
+	if (rc != EOK)
+		goto error;
+
+	*rtbcfg = tbcfg;
+	return EOK;
+error:
+	if (trans != NULL)
+		sif_trans_abort(trans);
+	if (repo != NULL)
+		sif_close(repo);
+	if (tbcfg != NULL)
+		free(tbcfg);
+	return rc;
+}
+
 /** Open taskbar configuration.
  *
@@ -52,5 +106,4 @@
 	sif_sess_t *repo = NULL;
 	sif_node_t *rnode;
-	sif_node_t *nentries;
 	sif_node_t *nentry;
 	const char *ntype;
@@ -74,6 +127,6 @@
 
 	rnode = sif_get_root(repo);
-	nentries = sif_node_first_child(rnode);
-	ntype = sif_node_get_type(nentries);
+	tbcfg->nentries = sif_node_first_child(rnode);
+	ntype = sif_node_get_type(tbcfg->nentries);
 	if (str_cmp(ntype, "entries") != 0) {
 		rc = EIO;
@@ -81,5 +134,5 @@
 	}
 
-	nentry = sif_node_first_child(nentries);
+	nentry = sif_node_first_child(tbcfg->nentries);
 	while (nentry != NULL) {
 		ntype = sif_node_get_type(nentry);
@@ -101,5 +154,5 @@
 		}
 
-		rc = smenu_entry_create(tbcfg, nentry, caption, cmd);
+		rc = smenu_entry_new(tbcfg, nentry, caption, cmd);
 		if (rc != EOK)
 			goto error;
@@ -124,5 +177,14 @@
 void tbarcfg_close(tbarcfg_t *tbcfg)
 {
+	smenu_entry_t *entry;
+
+	entry = tbarcfg_smenu_first(tbcfg);
+	while (entry != NULL) {
+		smenu_entry_delete(entry);
+		entry = tbarcfg_smenu_first(tbcfg);
+	}
+
 	(void)sif_close(tbcfg->repo);
+	free(tbcfg);
 }
 
@@ -229,5 +291,5 @@
 errno_t smenu_entry_save(smenu_entry_t *entry)
 {
-	sif_trans_t *trans;
+	sif_trans_t *trans = NULL;
 	errno_t rc;
 
@@ -255,5 +317,5 @@
 }
 
-/** Create a start menu entry and append it to the start menu (internal).
+/** Allocate a start menu entry and append it to the start menu (internal).
  *
  * This only creates the entry in memory, but does not update the repository.
@@ -264,5 +326,5 @@
  * @param cmd Command to run
  */
-errno_t smenu_entry_create(tbarcfg_t *smenu, sif_node_t *nentry,
+errno_t smenu_entry_new(tbarcfg_t *smenu, sif_node_t *nentry,
     const char *caption, const char *cmd)
 {
@@ -305,4 +367,84 @@
 }
 
+/** Delete start menu entry.
+ *
+ * This only deletes the entry from, but does not update the
+ * repository.
+ *
+ * @param entry Start menu entry
+ */
+void smenu_entry_delete(smenu_entry_t *entry)
+{
+	list_remove(&entry->lentries);
+	free(entry->caption);
+	free(entry->cmd);
+	free(entry);
+}
+
+/** Create new start menu entry.
+ *
+ * @param smenu Start menu
+ * @param nentry Backing SIF node
+ * @param caption Caption
+ * @param cmd Command to run
+ */
+errno_t smenu_entry_create(tbarcfg_t *smenu, const char *caption,
+    const char *cmd)
+{
+	sif_node_t *nentry;
+	errno_t rc;
+	sif_trans_t *trans = NULL;
+
+	rc = sif_trans_begin(smenu->repo, &trans);
+	if (rc != EOK)
+		goto error;
+
+	rc = sif_node_append_child(trans, smenu->nentries, "entry",
+	    &nentry);
+	if (rc != EOK)
+		goto error;
+
+	rc = smenu_entry_new(smenu, nentry, caption, cmd);
+	if (rc != EOK)
+		goto error;
+
+	rc = sif_trans_end(trans);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	if (trans != NULL)
+		sif_trans_abort(trans);
+	return rc;
+}
+
+/** Destroy start menu entry..
+ *
+ * @param entry Start menu entry
+ * @return EOK on success or an error code
+ */
+errno_t smenu_entry_destroy(smenu_entry_t *entry)
+{
+	errno_t rc;
+	sif_trans_t *trans = NULL;
+
+	rc = sif_trans_begin(entry->smenu->repo, &trans);
+	if (rc != EOK)
+		goto error;
+
+	sif_node_destroy(trans, entry->nentry);
+
+	rc = sif_trans_end(trans);
+	if (rc != EOK)
+		goto error;
+
+	smenu_entry_delete(entry);
+error:
+	if (trans != NULL)
+		sif_trans_abort(trans);
+	return rc;
+}
+
 /** @}
  */
Index: uspace/lib/tbarcfg/test/tbarcfg.c
===================================================================
--- uspace/lib/tbarcfg/test/tbarcfg.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/tbarcfg/test/tbarcfg.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -36,25 +36,27 @@
 PCUT_TEST_SUITE(tbarcfg);
 
-/** Opening and closing taskbar configuration */
-PCUT_TEST(open_close)
-{
-	errno_t rc;
-	tbarcfg_t *tbcfg;
-	FILE *f;
-	int rv;
-
-	f = fopen("/tmp/test", "wt");
-	PCUT_ASSERT_NOT_NULL(f);
-
-	rv = fputs("[sif](){[entries](){}}", f);
-	PCUT_ASSERT_TRUE(rv >= 0);
-
-	rv = fclose(f);
-	PCUT_ASSERT_INT_EQUALS(0, rv);
-
-	rc = tbarcfg_open("/tmp/test", &tbcfg);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	tbarcfg_close(tbcfg);
+/** Creating, opening and closing taskbar configuration */
+PCUT_TEST(create_open_close)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	/* Create new repository */
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open the repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
 }
 
@@ -64,21 +66,17 @@
 	errno_t rc;
 	tbarcfg_t *tbcfg;
-	smenu_entry_t *e;
-	FILE *f;
-	int rv;
-
-	f = fopen("/tmp/test", "wt");
-	PCUT_ASSERT_NOT_NULL(f);
-
-	rv = fputs("[sif](){[entries](){"
-	    "[entry]([caption]=[A][cmd]=[a]){}"
-	    "[entry]([caption]=[B][cmd]=[b]){}"
-	    "}}", f);
-	PCUT_ASSERT_TRUE(rv >= 0);
-
-	rv = fclose(f);
-	PCUT_ASSERT_INT_EQUALS(0, rv);
-
-	rc = tbarcfg_open("/tmp/test", &tbcfg);
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "B", "b");
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -91,4 +89,5 @@
 
 	tbarcfg_close(tbcfg);
+	remove(fname);
 }
 
@@ -98,22 +97,16 @@
 	errno_t rc;
 	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
 	smenu_entry_t *e;
 	const char *caption;
 	const char *cmd;
-	FILE *f;
-	int rv;
-
-	f = fopen("/tmp/test", "wt");
-	PCUT_ASSERT_NOT_NULL(f);
-
-	rv = fputs("[sif](){[entries](){"
-	    "[entry]([caption]=[A][cmd]=[a]){}"
-	    "}}", f);
-	PCUT_ASSERT_TRUE(rv >= 0);
-
-	rv = fclose(f);
-	PCUT_ASSERT_INT_EQUALS(0, rv);
-
-	rc = tbarcfg_open("/tmp/test", &tbcfg);
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a");
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -127,4 +120,98 @@
 
 	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Setting menu entry properties */
+PCUT_TEST(set_caption_cmd)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	/* Set properties */
+	rc = smenu_entry_set_caption(e, "B");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = smenu_entry_set_cmd(e, "b");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_save(e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Check that properties have been set */
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	/* Check that new values of properties have persisted */
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Create start menu entry */
+PCUT_TEST(entry_create)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
 }
 
Index: uspace/lib/ui/include/ui/list.h
===================================================================
--- uspace/lib/ui/include/ui/list.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/include/ui/list.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -60,4 +60,5 @@
 extern void *ui_list_entry_get_arg(ui_list_entry_t *);
 extern ui_list_t *ui_list_entry_get_list(ui_list_entry_t *);
+extern errno_t ui_list_entry_set_caption(ui_list_entry_t *, const char *);
 extern size_t ui_list_entries_cnt(ui_list_t *);
 extern errno_t ui_list_sort(ui_list_t *);
Index: uspace/lib/ui/include/ui/scrollbar.h
===================================================================
--- uspace/lib/ui/include/ui/scrollbar.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/include/ui/scrollbar.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -54,5 +54,5 @@
 extern void ui_scrollbar_set_rect(ui_scrollbar_t *, gfx_rect_t *);
 extern errno_t ui_scrollbar_paint(ui_scrollbar_t *);
-extern gfx_coord_t ui_scrollbar_through_length(ui_scrollbar_t *);
+extern gfx_coord_t ui_scrollbar_trough_length(ui_scrollbar_t *);
 extern gfx_coord_t ui_scrollbar_move_length(ui_scrollbar_t *);
 extern gfx_coord_t ui_scrollbar_get_pos(ui_scrollbar_t *);
@@ -60,9 +60,9 @@
 extern void ui_scrollbar_set_pos(ui_scrollbar_t *, gfx_coord_t);
 extern void ui_scrollbar_thumb_press(ui_scrollbar_t *, gfx_coord2_t *);
-extern void ui_scrollbar_up_through_press(ui_scrollbar_t *);
-extern void ui_scrollbar_down_through_press(ui_scrollbar_t *);
+extern void ui_scrollbar_upper_trough_press(ui_scrollbar_t *);
+extern void ui_scrollbar_lower_trough_press(ui_scrollbar_t *);
 extern void ui_scrollbar_release(ui_scrollbar_t *, gfx_coord2_t *);
 extern void ui_scrollbar_update(ui_scrollbar_t *, gfx_coord2_t *);
-extern void ui_scrollbar_throughs_update(ui_scrollbar_t *, gfx_coord2_t *);
+extern void ui_scrollbar_troughs_update(ui_scrollbar_t *, gfx_coord2_t *);
 extern void ui_scrollbar_up(ui_scrollbar_t *);
 extern void ui_scrollbar_down(ui_scrollbar_t *);
Index: uspace/lib/ui/meson.build
===================================================================
--- uspace/lib/ui/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'gfx', 'gfxfont', 'memgfx', 'display', 'congfx' ]
+deps = [ 'gfx', 'gfxfont', 'memgfx', 'display', 'congfx', 'clipboard' ]
 src = files(
 	'src/accel.c',
Index: uspace/lib/ui/private/resource.h
===================================================================
--- uspace/lib/ui/private/resource.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/private/resource.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -118,8 +118,8 @@
 	gfx_color_t *entry_sel_text_bg_color;
 
-	/** Scrollbar through color */
-	gfx_color_t *sbar_through_color;
-	/** Scrollbar active through color */
-	gfx_color_t *sbar_act_through_color;
+	/** Scrollbar trough color */
+	gfx_color_t *sbar_trough_color;
+	/** Scrollbar active trough color */
+	gfx_color_t *sbar_act_trough_color;
 
 	/** Expose callback or @c NULL */
Index: uspace/lib/ui/private/scrollbar.h
===================================================================
--- uspace/lib/ui/private/scrollbar.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/private/scrollbar.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -69,12 +69,12 @@
 	/** Thumb is currently held down */
 	bool thumb_held;
-	/** Up through is currently held down */
-	bool up_through_held;
-	/** Pointer is inside up through */
-	bool up_through_inside;
-	/** Down through is currently held down */
-	bool down_through_held;
-	/** Pointer is inside down through */
-	bool down_through_inside;
+	/** Upper trough is currently held down */
+	bool upper_trough_held;
+	/** Pointer is inside upper trough */
+	bool upper_trough_inside;
+	/** Lower trough is currently held down */
+	bool lower_trough_held;
+	/** Pointer is inside lower trough */
+	bool lower_trough_inside;
 	/** Position where thumb was pressed */
 	gfx_coord2_t press_pos;
@@ -83,5 +83,5 @@
 	/** Thumb position */
 	gfx_coord_t pos;
-	/** Last cursor position (when through is held) */
+	/** Last cursor position (when trough is held) */
 	gfx_coord2_t last_curs_pos;
 };
@@ -94,12 +94,12 @@
 	/** Up button rectangle */
 	gfx_rect_t up_btn_rect;
-	/** Through rectangle */
-	gfx_rect_t through_rect;
-	/** Up through rectangle */
-	gfx_rect_t up_through_rect;
+	/** Trough rectangle */
+	gfx_rect_t trough_rect;
+	/** Upper trough rectangle */
+	gfx_rect_t upper_trough_rect;
 	/** Thumb rectangle */
 	gfx_rect_t thumb_rect;
-	/** Down through rectangle */
-	gfx_rect_t down_through_rect;
+	/** Lower trough rectangle */
+	gfx_rect_t lower_trough_rect;
 	/** Down button rectangle */
 	gfx_rect_t down_btn_rect;
Index: uspace/lib/ui/src/clickmatic.c
===================================================================
--- uspace/lib/ui/src/clickmatic.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/ui/src/clickmatic.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,5 +35,5 @@
  * Clickmatic is used to periodically generate events in particular cases
  * when a mouse button is held down, such as when holding the button or
- * through of a scrollbar.
+ * trough of a scrollbar.
  */
 
